# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from voiceos.models.azure_model import AzureModel
from typing import Optional, Set
from typing_extensions import Self

class AzureSynthesizer(BaseModel):
    """
    AzureSynthesizer
    """ # noqa: E501
    provider: Optional[StrictStr] = Field(default='azure', description="The synthesizer provider.")
    model: Optional[AzureModel] = Field(default=None, description="The azure model to use")
    pitch: Optional[Annotated[int, Field(le=20, strict=True, ge=-20)]] = Field(default=0, description="The pitch of the voice")
    rate: Optional[Annotated[int, Field(le=50, strict=True, ge=-50)]] = Field(default=0, description="The rate of the voice")
    __properties: ClassVar[List[str]] = ["provider", "model", "pitch", "rate"]

    @field_validator('provider')
    def provider_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['azure']):
            raise ValueError("must be one of enum values ('azure')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AzureSynthesizer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AzureSynthesizer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "provider": obj.get("provider") if obj.get("provider") is not None else 'azure',
            "model": obj.get("model"),
            "pitch": obj.get("pitch") if obj.get("pitch") is not None else 0,
            "rate": obj.get("rate") if obj.get("rate") is not None else 0
        })
        return _obj


