# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from voiceos.models.deepgram_languages import DeepgramLanguages
from voiceos.models.deepgram_model import DeepgramModel
from typing import Optional, Set
from typing_extensions import Self

class DeepgramTranscriber(BaseModel):
    """
    DeepgramTranscriber
    """ # noqa: E501
    provider: Optional[StrictStr] = Field(default='deepgram', description="The transcriber provider.")
    model: Optional[DeepgramModel] = Field(default=None, description="The deepgram model to use.")
    language: Optional[DeepgramLanguages] = Field(default=None, description="The selected language for the transcription.")
    keywords: Optional[List[StrictStr]] = Field(default=None, description="Specific keywords you want to detect in the transcription. This is usefull to correctly understand product or company names.")
    __properties: ClassVar[List[str]] = ["provider", "model", "language", "keywords"]

    @field_validator('provider')
    def provider_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['deepgram']):
            raise ValueError("must be one of enum values ('deepgram')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeepgramTranscriber from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeepgramTranscriber from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "provider": obj.get("provider") if obj.get("provider") is not None else 'deepgram',
            "model": obj.get("model"),
            "language": obj.get("language"),
            "keywords": obj.get("keywords")
        })
        return _obj


